require 'yaml'
require_relative 'non_hash'
require_relative 'exceptions'

module NonConfig
  #
  # Hash with filepath and {#save} method
  #
  class ConfigFile < NonHash
    attr_reader :path

    # parses yaml from path
    def initialize(path = nil)
      super()
      return unless path
      fail FileNotFound unless File.exist? path

      @path = path
      file_data = File.read @path
      records = YAML.load file_data
      merge! self.class.from_hash(records)
    end

    # rewrite file so you can save your changes
    def save
      File.open(@path, 'w') { |f| f.write to_yaml }
    end
  end
end
